<?php
/*
 * RSS-Feed Generator fr CMBasic
 * Erzeugt ein Dynamisches RSS 2.0 Feed fr News Seiten
 *
 * @version 1.2
 * @author Matthias Fleischer
 * @copyright 2008 by MFD|WEB http://www.mfdweb.de
 * @lizenz CreativeCommons cc-by-sa 3.0 de (Namensnennung-Weitergabe unter gleichen Bedingungen 3.0 Deutschland) http://creativecommons.org/licenses/by-sa/3.0/de/
 */

include('edit/config.inc.php');

$domainURL = "http://$_SERVER[SERVER_NAME]";
$feed = htmlentities(strip_tags(trim($_SERVER['QUERY_STRING']), ENT_QUOTES));

if (preg_match("|^[a-zA-Z0-9_-]+$|", $feed) == 0) die("<b>Ungltige Eingabe!</b>"); // Skript bricht bei Manipulationsversuch ab

$dz = @mysql_connect($dbhost, $dbuser, $dbpassword) or die("<b>Eine Verbindung zum Datenbankserver konnte nicht hergestellt werden!</b>");
@mysql_select_db($dbname, $dz) or die("<b>Die Verbindung zur Datenbank konnte nicht hergestellt werden!</b>");

$counter = @mysql_result(@mysql_query("SELECT COUNT(*) FROM {$pfx}content WHERE URLAnhang = '$feed'"), 0); // Prft ob Page vorhanden
if ($counter == 1) {
    $ds = @mysql_fetch_object(@mysql_query("SELECT * FROM {$pfx}content WHERE URLAnhang = '$feed'")); // Holt den Content der Page
    $getAnhang = $ds->URLAnhang;
    $MenueName = $ds->MenueName;
    $Ebene1 = $ds->Ebene1;
    $Ebene2 = $ds->Ebene2;
    $Seitentitel = $ds->Seitentitel;
    $Content = $ds->Content;
    if ($friendlyURL == 1) {
        $homeURL = "$domainURL/$getAnhang.html";
    } else {
        $homeURL = "$domainURL/?$getAnhang";
    }
    $rss = false;
    $item = "";
    $date = date('r');

    preg_match_all("/{((news|blog|list|menu),?[0-9]*,?[a-z]*)}/i", $Content, $markerfund); // Ermittelt ob Eintrag enthalten
    if (!empty($markerfund[1])) {
        foreach($markerfund[1] as $markername_komp) {
            $markername = explode(",", $markername_komp);
            if (!empty($markername[1])) {
                $subKat1 = $markername[1];
            } else if (empty($markername[1])) {
                $subKat1 = $Ebene1;
            }
            if (!empty($markername[2])) {
                if ($markername[2] == 'rss') { // Prft ob RSS gewnscht
                    $rss = true;
                    if ($friendlyURL == 1) {
                        $selfURL = "$domainURL/$getAnhang.rss";
                    } else {
                        $selfURL = "$domainURL/rssfeed.php?$getAnhang";
                    }

                    $sql = @mysql_query("SELECT * FROM {$pfx}content WHERE Ebene1 = $subKat1 AND Ebene2 > 0 ORDER BY Ebene2 ASC");
                    while ($listrow = @mysql_fetch_assoc($sql)) { // Auslesen der eingetragenen Pages
                    
                        if (isset($newblog) && $newblog == 1) {
                            $Page_date = $listrow['MenueName']; // Als Mennamen ein Datum benutzen (tt.mm.jjjj)      
                            $anreisser = "";
                            if (preg_match("/{((desc)=(.*?))}/i", $listrow['Content'], $newdescfund) > 0) {
                                $anreisser = explode("=", "$newdescfund[1]");
                                $newmuster = "|{{$newdescfund[1]}}|";
                                $anreisser = $anreisser[1];
                                $$listrow['Content'] = preg_replace($newmuster, "", $listrow['Content']);
                            } else {
                                preg_match_all("|<[^>]+>(.*)</[^>]+>|U", $listrow['Content'], $newdesctag, PREG_PATTERN_ORDER);
                                $anreisser = $newdesctag[1][1];
                                if (!empty($anreisser)) {
                                    if (isset($nohead) && $nohead == 1) { $anreisser = $newdesctag[1][0]; }
                                    }
                                }
  
                            if (!empty($anreisser)) {
                                $anreisser = strip_tags($anreisser);
                                $anreisser = htmlspecialchars($anreisser);
                            }           
                        } else {                         
                         
                        $Page_date = $listrow['MenueName']; // Als Mennamen ein Datum benutzen (tt.mm.jjjj)
                        $anreisser = $listrow['Content'];
                        $anreisser = preg_replace("|</h1>|", "... ", $anreisser);
                        $anreisser = preg_replace("|<h2>|", " - ", $anreisser);
                        $anreisser = preg_replace("|</h2>|", ". ", $anreisser);
                        $anreisser = preg_replace("|</h3>|", " ", $anreisser);
                        $anreisser = preg_replace("|</h4>|", " ", $anreisser);
                        $anreisser = preg_replace("|<li>|", " - ", $anreisser);
                        $anreisser = preg_replace("|</li>|", " ", $anreisser);
                        $anreisser = preg_replace("|<br />|", " ", $anreisser);
                        $anreisser = preg_replace("|</p>|", " ", $anreisser);
                        $anreisser = strip_tags($anreisser);
                        $anreisser = htmlspecialchars_decode($anreisser);
                        $anreisser = preg_replace("/\s\s+/", " ", trim($anreisser));

                        if (strlen($anreisser) > 240) {
                            $cutstring = substr($anreisser, 240, 260);
                            $cutstring = explode(' ', $cutstring);
                            $cutlaenge = strlen($cutstring[0]);
                            $neulaenge = 240 + $cutlaenge;
                            $anreisser = substr($anreisser, 0, $neulaenge);
                            $anreisser .= " ...";
                        }
                        
                        }
                        $item .= "\n  <item>\n   <title>$listrow[Seitentitel]</title>\n";

                        if ($subKat1 >= 100) {
                            if ($friendlyURL == 1) {
                                $Link = "$domainURL/$getAnhang,$listrow[URLAnhang].html";
                            } else {
                                $Link = "$domainURL/?$getAnhang,$listrow[URLAnhang]";
                            }
                            $item .= "   <link>$Link</link>\n";
                            $item .= "   <description><![CDATA[$anreisser <a href=\"$Link\" title=\"$listrow[Seitentitel]\">Gesamten Beitrag lesen ...</a>]]></description>\n";
                        } else {
                            if ($friendlyURL == 1) {
                                $Link = "$domainURL/$listrow[URLAnhang].html";
                            } else {
                                $Link = "$domainURL/?$listrow[URLAnhang]";
                            }
                            $item .= "   <link>$Link</link>\n";
                            $item .= "   <description><![CDATA[$anreisser <a href=\"$Link\" title=\"$listrow[Seitentitel]\">Gesamten Beitrag lesen ...</a>]]></description>\n";
                        }
                        if (!empty($Page_date)) {
                            $datesearch = array("Januar", "Februar", "Mrz", "Mai", "Juni", "Juli", "Oktober", "Dezember");
                            $datereplace = array("January", "February", "March", "May", "June", "July", "October", "December");
                            $Page_date = str_replace($datesearch, $datereplace, $Page_date);
                            $Page_date = strtotime($Page_date);
                            $Page_date = date('r', $Page_date);
                            $item .= "   <pubDate>$Page_date</pubDate>\n";
                        }
                        $item .= "   <guid isPermaLink=\"false\">$listrow[URLAnhang]</guid>\n  </item>\n";
                    }
                }
            }
        }
        @mysql_close($dz); // Beendet die Datenbankverbindung

        if ($rss == true) {
            header("Content-Type: application/rss+xml"); // Ausgabe des Content als RSS XML
            echo("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>
<rss version=\"2.0\" xmlns:atom=\"http://www.w3.org/2005/Atom\">\n
 <channel>
  <title>$Seitentitel</title>
  <link>$homeURL</link>
  <description>$MenueName</description>
  <language>de-de</language>
  <copyright>$domainURL</copyright>
  <pubDate>$date</pubDate>
$item
  <atom:link href=\"$selfURL\" rel=\"self\" type=\"application/rss+xml\" />
 </channel>
</rss>");
        } else { // Fehler: RSS nicht gewnscht
            header("HTTP/1.0 404 Not Found");
            header('Status: 404 Not Found');
            header('Location: /', true, 404);
            header('Connection: close');
            exit("<h1>404 Not Found</h1><p>Die angegebene Datei wurde entfernt!<p>");
        }
    } else { // Fehler: Eintrag nicht gefunden
        header("HTTP/1.0 404 Not Found");
        header('Status: 404 Not Found');
        header('Location: /', true, 404);
        header('Connection: close');
        exit("<h1>404 Not Found</h1><p>Die angegebene Datei existiert nicht mehr!<p>");
    }
} else { // Fehler: Page nicht vorhanden
    header('HTTP/1.0 404 Not Found');
    header('Status: 404 Not Found');
    header('Location: /', true, 404);
    header('Connection: close');
    exit("<h1>404 Not Found</h1><p>Die angegebene Datei wurde nicht gefunden!</p>");
}

?>
